scala.xml

# Utility

#### object Utility extends TokenTests

The `Utility` object provides utility functions for processing instances of bound and not bound XML classes, as well as escaping text nodes.

Source
  Utility.scala

Linear Supertypes
TokenTests, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Utility
2. TokenTests
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### object Escapes extends AnyRef

7. #### final val SU: Char(\'\032\')

8. #### def appendEscapedQuoted(s: String, sb: StringBuilder): StringBuilder

   Appends "s" and escapes and " i s with \"

   Appends "s" and escapes and " i s with \"

   s

     ...

   sb

     ...

   returns

     ...

9. #### def appendQuoted(s: String, sb: StringBuilder): StringBuilder

   Appends "s" if string `s` does not contain ", 's' otherwise.

   Appends "s" if string `s` does not contain ", 's' otherwise.

   s

     ...

   sb

     ...

   returns

     ...

10. #### def appendQuoted(s: String): String

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

12. #### def checkAttributeValue(value: String): String

    Returns `null` if the value is a correct attribute value, error message if it isn't.

    Returns `null` if the value is a correct attribute value, error message if it isn't.

    value

      ...

    returns

      ...

13. #### def checkPubID(s: String): Boolean

    Definition Classes
      TokenTests

14. #### def checkSysID(s: String): Boolean

    Definition Classes
      TokenTests

15. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

16. #### def collectNamespaces(n: Node, set: Set[String]): Unit

    Adds all namespaces in node to set.

    Adds all namespaces in node to set.

    n

      ...

    set

      ...

17. #### def collectNamespaces(nodes: Seq[Node]): Set[String]

    Returns a set of all namespaces used in a sequence of nodes and all their descendants, including the empty namespaces.

    Returns a set of all namespaces used in a sequence of nodes and all their descendants, including the empty namespaces.

    nodes

      ...

    returns

      ...

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

20. #### final def escape(text: String, s: StringBuilder): StringBuilder

    Appends escaped string to `s`.

    Appends escaped string to `s`.

    text

      ...

    s

      ...

    returns

      ...

21. #### final def escape(text: String): String

    Escapes the characters < > & and " from string.

    Escapes the characters < > & and " from string.

    text

      ...

    returns

      ...

22. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

23. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

24. #### def getName(s: String, index: Int): String

    s

      ...

    index

      ...

    returns

      ...

25. #### def hashCode(pre: String, label: String, attribHashCode: Int, scpeHash: Int, children: Seq[Node]): Int

    Returns a hashcode for the given constituents of a node

    Returns a hashcode for the given constituents of a node

    label
    attribHashCode
    children

26. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

27. #### implicit def implicitSbToString(sb: StringBuilder): String

28. #### def isAlpha(c: Char): Boolean

    These are 99% sure to be redundant but refactoring on the safe side.

    These are 99% sure to be redundant but refactoring on the safe side.

    Definition Classes
      TokenTests

29. #### def isAlphaDigit(c: Char): Boolean

    Definition Classes
      TokenTests

30. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

31. #### def isName(s: String): Boolean

    Name ::= ( Letter | '_' ) (NameChar)*

    Name ::= ( Letter | '_' ) (NameChar)*

    see [5] of XML 1.0 specification

    Definition Classes
      TokenTests

32. #### def isNameChar(ch: Char): Boolean

    NameChar ::= Letter | Digit | '.

    NameChar ::= Letter | Digit | '.' | '-' | '_' | ':' | CombiningChar | Extender

    see [4] and Appendix B of XML 1.0 specification

    Definition Classes
      TokenTests

33. #### def isNameStart(ch: Char): Boolean

    NameStart ::= ( Letter | '_' ) where Letter means in one of the Unicode general categories { Ll, Lu, Lo, Lt, Nl }

    NameStart ::= ( Letter | '_' ) where Letter means in one of the Unicode general categories { Ll, Lu, Lo, Lt, Nl }

    We do not allow a name to start with ':'. see [3] and Appendix B of XML 1.0 specification

    Definition Classes
      TokenTests

34. #### def isPubIDChar(ch: Char): Boolean

    Definition Classes
      TokenTests

35. #### final def isSpace(cs: Seq[Char]): Boolean

    (#x20 | #x9 | #xD | #xA)+

    (#x20 | #x9 | #xD | #xA)+

    Definition Classes
      TokenTests

36. #### final def isSpace(ch: Char): Boolean

    (#x20 | #x9 | #xD | #xA)

    (#x20 | #x9 | #xD | #xA)

    Definition Classes
      TokenTests

37. #### def isValidIANAEncoding(ianaEncoding: Seq[Char]): Boolean

    Returns true if the encoding name is a valid IANA encoding.

    Returns true if the encoding name is a valid IANA encoding. This method does not verify that there is a decoder available for this encoding, only that the characters are valid for an IANA encoding name.

    ianaEncoding

      The IANA encoding name.

    Definition Classes
      TokenTests

38. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

39. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

40. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41. #### def parseAttributeValue(value: String): Seq[Node]

    new

    new

    value

      ...

    returns

      ...

42. #### def parseCharRef(ch: () ⇒ Char, nextch: () ⇒ Unit, reportSyntaxError: (String) ⇒ Unit, reportTruncatedError: (String) ⇒ Unit): String

          CharRef ::= "&#" '0'..'9' {'0'..'9'} ";"
                    | "&#x" '0'..'9'|'A'..'F'|'a'..'f' { hexdigit } ";"

          CharRef ::= "&#" '0'..'9' {'0'..'9'} ";"
                    | "&#x" '0'..'9'|'A'..'F'|'a'..'f' { hexdigit } ";"

    see [66]

    ch

      ...

    nextch

      ...

    reportSyntaxError

      ...

    returns

      ...

43. #### final def prefix(name: String): Option[String]

    Returns prefix of qualified name if any.

    Returns prefix of qualified name if any.

    name

      ...

    returns

      ...

44. #### def sequenceToXML(children: Seq[Node], pscope: NamespaceBinding = TopScope, sb: StringBuilder = new StringBuilder, stripComments: Boolean = false, decodeEntities: Boolean = true, preserveWhitespace: Boolean = false, minimizeTags: Boolean = false): Unit

45. #### def sort(n: Node): Node

    returns the node with its attribute list sorted alphabetically (prefixes are ignored)

46. #### def sort(md: MetaData): MetaData

    returns a sorted attribute list

47. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

48. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

49. #### def toXML(x: Node, pscope: NamespaceBinding = TopScope, sb: StringBuilder = new StringBuilder, stripComments: Boolean = false, decodeEntities: Boolean = true, preserveWhitespace: Boolean = false, minimizeTags: Boolean = false): StringBuilder

50. #### def trim(x: Node): Node

    trims an element - call this method, when you know that it is an element (and not a text node) so you know that it will not be trimmed away.

    trims an element - call this method, when you know that it is an element (and not a text node) so you know that it will not be trimmed away. With this assumption, the function can return a `Node`, rather than a `Seq[Node]`. If you don't know, call `trimProper` and account for the fact that you may get back an empty sequence of nodes.

    precondition: node is not a text node (it might be trimmed)

51. #### def trimProper(x: Node): Seq[Node]

    trim a child of an element.

    trim a child of an element. `Attribute` values and `Atom` nodes that are not `Text` nodes are unaffected.

52. #### final def unescape(ref: String, s: StringBuilder): StringBuilder

    Appends unescaped string to `s`, amp becomes & lt becomes < etc.

    Appends unescaped string to `s`, amp becomes & lt becomes < etc..

    ref

      ...

    s

      ...

    returns

      `null` if `ref` was not a predefined entity.

53. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

54. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

55. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from TokenTests

### Inherited from AnyRef

### Inherited from Any